
-- TO DO
    -- implement overlays for Options (@Menu) and in-game menu (@Play)
    

-- initialize graphics
screen = {}
screen.w, screen.h = love.graphics.getDimensions()

-- initialize map
map = {}
map.x, map.y = 23, 15
for x = 1, map.x do
    map[x] = {}
end

-- initialize player
player = {}
player.name = "milon"
player.active = true

-- initialize states
state = {}
state.fail = require("states.fail")
state.load = require("states.load")
state.menu = require("states.menu")
state.play = require("states.play")
state.quit = require("states.quit")
state.current = state.menu

-- initialize overlay
--~ overlay = require("overlay")

-- Love settings
love.math.setRandomSeed(love.timer.getTime())
love.keyboard.setKeyRepeat(true)

-- screenshot callback
function getScreenshot(ImageData)
    screen.screenshot = love.graphics.newImage(ImageData)
    ImageData:release()
    ImageData = nil
end


-- define love functions:

function love.load()
    defaultFont = love.graphics.getFont()
end

function love.draw()
    state.current.draw()
    -- anything drawn here will show on EVERY screen
    -- It's usually best to not actually do this
    love.graphics.setFont(defaultFont)
    love.graphics.setColor(1, 1, 1, 0.5)
    love.graphics.rectangle("fill", 0, 530, 800, 70)
    love.graphics.setColor(0, 0, 0, 1)
    love.graphics.print("There are a LOT of improvements that could be made to this, especially how GUI elements are handled", 9, 534)
    love.graphics.print("This is all original work by milon", 9, 564)
    love.graphics.print("License CC0: Do whatever you want with this", 9, 579)
end

function love.keypressed(key)
    state.current.keypressed(key)
end

function love.update(dt)
    state.current.update(dt)
end
