
local M = {}

-- This is a fake loading screen
-- There's not much to load here, so in practice we wouldn't bother with this
-- It's probably best to perform slow loading in a separate thread so the UI stays responsive to the player

-- initialize
local orientation
local loadingImage = love.graphics.newImage("images/loading.png")
player.image = love.graphics.newImage("images/hero.png")

-- The loading function
function M.pseudoLoad(level)
    
    -- initialize graphics
    orientation = 0
    if screen.screenshot then
        screen.screenshot:release()
        screen.screenshot = nil
    end
    
    -- "load" a map
    for x = 1, map.x do
        for y = 1, map.y do
            map[x][y] = {love.math.random(), love.math.random(), love.math.random()}
        end
    end

    -- initialize player
    player.x, player.y = 1, 1
    player.active = true
    player.level = level
end


function M.draw()
    love.graphics.clear(1, 1, 1)
    love.graphics.setColor(1, 1, 1)
    love.graphics.draw(loadingImage, 375, 275, orientation)
    
    love.graphics.setColor(0, 0, 0)
    love.graphics.print("LOL, that's supposed to spin in place\nMaybe I'll fix it later  :P", 10, 300)
end

function M.keypressed(key)
end

function M.update(dt)
    orientation = orientation + dt * 2
    if orientation > 2 * math.pi then state.current = state.play end
end

return M
