
local M = {}

function M.draw()
    love.graphics.clear(0, 0, 0, 1)
    for x = 1, map.x do
        for y = 1, map.y do
            love.graphics.setColor(map[x][y])
            love.graphics.rectangle("fill", x * 32, y * 32, 32, 32)
        end
    end
    love.graphics.setColor(1, 1, 1)
    love.graphics.print("Player: "..player.name, 10, 10)
    love.graphics.print("Level: "..player.level, 200, 10)
    love.graphics.draw(player.image, player.x * 32, player.y * 32)
    love.graphics.print("goal", 739, 489)
    love.graphics.setColor(0, 0, 0)
    love.graphics.print("goal", 740, 490)
    love.graphics.setColor(1, 1, 1)
    love.graphics.print("NO!", 35, 489)
    love.graphics.setColor(0, 0, 0)
    love.graphics.print("NO!", 36, 490)
    
end

function M.keypressed(key)
    if not player.active then
        -- do nothing
    elseif key == "left" then
        if player.x > 1 then player.x = player.x - 1 end
    elseif key == "right" then
        if player.x < map.x then player.x = player.x + 1 end
    elseif key == "up" then
        if player.y > 1 then player.y = player.y - 1 end
    elseif key == "down" then
        if player.y < map.y then player.y = player.y + 1 end
    elseif key == "space" or key == "return" then
        -- fixme: overlay game menu
    elseif key == "escape" then
        state.current = state.menu
        -- fixme: overlay game menu
    end
    if player.x == 1 and player.y == map.y then
        player.active = false
        love.graphics.captureScreenshot(getScreenshot)
        player.timer = love.timer.getTime()
    elseif player.x == map.x and player.y == map.y then
        player.active = false
        state.current = state.load
        state.load.pseudoLoad(player.level + 1)
    end
end

function M.update(dt)
    -- wait for screenshot to be available before finishing
    if not player.active and screen.screenshot then state.current = state.fail end
end

return M
